unit prefs;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, vector;

type
  TPreferences = class(TForm)
    Label1: TLabel;
    DistUni: TEdit;
    Label3: TLabel;
    DistPow: TEdit;
    MassUni: TEdit;
    Label5: TLabel;
    MassPow: TEdit;
    Label6: TLabel;
    Label7: TLabel;
    VelocityVal: TEdit;
    Label9: TLabel;
    Day: TEdit;
    Label11: TLabel;
    Hours: TEdit;
    Label12: TLabel;
    Minutes: TEdit;
    Label13: TLabel;
    Seconds: TEdit;
    Label14: TLabel;
    Mass: TGroupBox;
    Time: TGroupBox;
    Velocity: TGroupBox;
    Distance: TGroupBox;
    Cancel: TButton;
    Ok: TButton;
    Force: TGroupBox;
    Label2: TLabel;
    Label4: TLabel;
    FrUni: TEdit;
    FrPow: TEdit;
    procedure CancelClick(Sender: TObject);
    procedure OkClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

implementation

uses main;

{$R *.dfm}

procedure TPreferences.CancelClick(Sender: TObject);
begin
  self.Hide;
  Form1.enabled:=True;
  Form1.aktualize;
end;

procedure TPreferences.OkClick(Sender: TObject);
var tmp1, tmp2: variant;
    err: boolean;
begin
  err:=false;
try
  tmp1:=VelocityVal.Text;
  Universe.constants.v:=tmp1;
  tmp1:=MassUni.Text;
  tmp2:=MassPow.Text;
  Universe.constants.m:=tmp1*power(10,tmp2);
  tmp1:=FrUni.Text;
  tmp2:=FrPow.Text;
  Universe.constants.f:=tmp1*power(10,-(tmp2));
  tmp1:=DistUni.Text;
  tmp2:=DistPow.Text;
  Universe.constants.l:=tmp1*power(10,tmp2);
  tmp1:=day.Text;
  tmp2:=hours.Text;
  universe.constants.t:=(tmp1*24+tmp2)*60;
  tmp1:=minutes.Text;
  tmp2:=seconds.Text;
  universe.constants.t:=((universe.constants.t+tmp1)*60+tmp2)*10;
except
  err:=true;
end;
  if err=True then
    begin
      showmessage('Invalid value(s) in input field(s)!!!');
    end else begin
      universe.Refresh;
      CancelClick(self);
    end;
end;

end.
